Description

So, not sure if this is just my freaky environment, where I have hosts whose fqdn really is:

willy.freaky.com

but they have a hardcoded fqdn in puppet as:

willy.deaky.net

From Foreman and Puppets point of view, the hosts are named *.deaky.net.

When editing a Host, the normalize_hostname filter will append $domain to the end of the fqdn, thus renaming the host:

willy.deaky.net.freaky.com

Associated revisions

Revision 0c8f532e - 05/22/2013 10:50 AM - Mikael Fridh

fixes #2130 - normalize_hostname appends domainname to fqdn

When the trailing part of $fqdn doesn't match $domain, the normalize_hostname

function would append $domain onto the end of $fqdn, saving the host as

$fqdn.$domain (Example: hostname.domain1.com.domain2.com).

This rename would happen if you edit a host already named 'host.domain1.com'

where a (hardcoded) certname says 'host.domain1.com' but the domain fact says

'domain2.com'.

If a hostname is supposed to follow RFC952 format, any . (dot) is only allowed

as a separator between domain parts and not in the hostname part itself.

Thus if there is already a dot in the hostname we have to assume the host name

(fqdn) is already fully qualified.

Revision c72cc3b1 - 05/23/2013 04:00 AM - Mikael Fridh

fixes #2130 - normalize_hostname appends domainname to fqdn

When the trailing part of $fqdn doesn't match $domain, the normalize_hostname

function would append $domain onto the end of $fqdn, saving the host as

$fqdn.$domain (Example: hostname.domain1.com.domain2.com).

This rename would happen if you edit a host already named 'host.domain1.com'

where a (hardcoded) certname says 'host.domain1.com' but the domain fact says

'domain2.com'.

If a hostname is supposed to follow RFC952 format, any . (dot) is only allowed

as a separator between domain parts and not in the hostname part itself.

Thus if there is already a dot in the hostname we have to assume the host name

(fqdn) is already fully qualified.

(cherry picked from commit 0c8f532ed251049dcd93f6ce054f07093f9507f8)

History

#1 - 01/15/2013 06:14 PM - Mikael Fridh
I'm thinking either this patch, or simply matching one dot /\./

diff --git a/app/models/host.rb b/app/models/host.rb

index fcb8838..9e81b9a 100644

--- a/app/models/host.rb

+++ b/app/models/host.rb

@@ -819,7 +819,7 @@ class Host < Puppet::Rails::Host

         old_domain = Domain.find(changed_attributes["domain_id"])

         self.name.gsub(old_domain.to_s,"")

       end

-      self.name += ".#{domain}" unless name =~ /.#{domain}$/i

+      self.name += ".#{domain}" unless name =~ /\..*\./i

     end

   end

#2 - 01/15/2013 08:17 PM - Mikael Fridh

pullreq https://github.com/theforeman/foreman/pull/376 I opted for the single-dot patch.

#3 - 02/13/2013 10:20 AM - Mikael Fridh

- Target version set to 1.2.0

I'll just set this to 1.2 for consideration as there was some agreement on #theforeman-dev that the patch does make some sense. Why should hosts

be renamed if they already look like an fqdn style hostname. I'm unaware of an edge case where it would make sense but please enlighten me if you

do!

#4 - 05/07/2013 03:33 PM - Dominic Cleal

- Status changed from New to Ready For Testing

- Assignee changed from Ohad Levy to Mikael Fridh

#5 - 05/22/2013 10:56 AM - Mikael Fridh

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 0c8f532ed251049dcd93f6ce054f07093f9507f8.
